# Docker image for Kameleoon Nginx Module - Installation Instructions

1) Add your `client id`, `client secret` and `site_codes` to the `configuration.json` file. `site_codes` is an array, so you can use several Kameleoon site codes.
    
    ```json
    {
        "client_id": "YOUR_CLIENT_ID",
        "client_secret": "YOUR_CLIENT_SECRET",
        "site_codes": ["YOUR_SITE_CODE"],

        "api_url": "https://api.kameleoon.com",
        "nginxConfigurationFile": "/etc/nginx/modules/00-kameleoon.conf"
    }
    ```
    
2) Build the Docker image with the command `docker build .`.

3) Further configuration (optional):

* You can configure your Nginx server context in the file `kameleoon-server.conf`. 
Do not remove this instruction `include /etc/nginx/modules/00-kameleoon.conf;`.
    * You can enable/disable the module with this option: `kameleoon_module on;`.
    * You can return targeted experiments as a list in a header with this option: `kameleoon_experiments_header on;`.
    * You can choose the domain of the cookie with this option: `kameleoon_domain_cookie ".my-domain.com";`. 
    By default, without the option the module does not add any domain to the kameleoon cookie, you can also use a variable.
    
* You can configure your Nginx location context in the file `kameleoon-server.conf`.
    * You can ignore the module with this option: `kameleoon_ignore true;`.
    By default, the option is set to false, therefore is will not ignore the kameleoon module, you can also use a variable.

* You can edit the main Nginx configuration in the file `nginx.conf`. 
Do not remove the instruction `load_module /etc/nginx/modules/ngx_kameleoon_module.so;` in the main context otherwise the module will not load.

* You can change the interval of time the cron job is executed in the file `kameleoon-cron`.
